/**
 * Created by Barry (barry@coilgun.info) at Sep 22, 2005 8:17:26 AM
 * To change this template use Options | File Templates.
 */

import junit.framework.TestCase;

public final class CoilSim20Test extends TestCase {
    /* private Nearest nearest; */

    /**
     * The fixture called before every test method.
     */
    protected void setUp() throws Exception {
        /* nearest = new Nearest(); */
    }

    /**
     * The fixture cleanup called after every test method.
     */
    protected void tearDown() throws Exception {
        super.tearDown();
    }

    public void test_init() {
        System.out.println("test_init");
        CoilSim20 coilsim = new CoilSim20();
        coilsim.init();
        final float SLIDER_STEPS = 200;
        // initial values are stored in JSliderFloat, which rounds everything to the nearest minor tic
        // so we'll allow a delta of 1% in all these settings
        assertEquals(CoilSim20.INIT_VOLTAGE,     coilsim.m_voltage,     CoilSim20.INIT_VOLTAGE/SLIDER_STEPS);
        assertEquals(CoilSim20.INIT_RESISTANCE,  coilsim.m_resistance,  CoilSim20.INIT_RESISTANCE/SLIDER_STEPS);
        assertEquals(CoilSim20.INIT_CAPACITANCE, coilsim.m_capacitance, CoilSim20.INIT_CAPACITANCE/40.F);
        assertEquals(CoilSim20.INIT_INDUCTANCE,  coilsim.m_inductance,  CoilSim20.INIT_INDUCTANCE/SLIDER_STEPS);

        // simulate at least TWO cycles of natural frequency
        double natural_freq = 1.F / (2 * Math.PI * Math.sqrt(coilsim.m_inductance * coilsim.m_capacitance));
        double expected_et = 2.F / natural_freq;
        expected_et = Nearest.HalfDecade(expected_et);
        assertEquals(expected_et, coilsim.m_elapsed_time, expected_et/1000.);
    }

    public void test_diodeCurrent() {
        System.out.println("test_diode");
        CoilSim20 coilsim = new CoilSim20();
        coilsim.init();

        // no leakage current
        assertEquals( 0., SimState.diodeCurrent(-5.), 1.E-6);
        assertEquals( 0., SimState.diodeCurrent(0.), 1.E-6);

        // forward current 100 amps, at 1.4 volts
        // forward current 1000 amps, at 1.6 volts
        assertEquals( 100., SimState.diodeCurrent(1.4), 0.001);
        assertEquals( 1000., SimState.diodeCurrent(1.6), 0.001);
    }
}    